Matrices II: Algebra matricial
1 Introduccin
2 Operaciones elementales con matrices
2.1 Transpuesta de una matriz
2.2 Matriz conjugada
2.3 Suma de matrices
2.4 Producto de un escalar por una matriz
2.5 Producto matricial de dos matrices
2.6 Producto elemento a elemento de dos matrices
2.7 Producto cruzado de dos matrices
2.8 Determinante de una matriz
3 Tipos de matrices
3.1 Matrices cuadradas
3.2 Matrices rectangulares
3.3 Matriz simtrica
3.4 Matriz diagonal
3.5 Matriz identidad
3.6 Matriz J
3.7 Matriz nula
3.8 Matriz idempotente
3.9 Matriz nilpotente
3.10 Matriz ortogonal
3.11 Matriz triangular superior
3.12 Matriz triangular inferior
3.12.1 Funcin lower.tri()
3.12.2 Funcin upper.tri()
3.13 Traza de una matriz
1 Introduccin
Las matrices se notarn por letras maysculas y los vectores por letras minsculas ambos en negrita. En erl caso de los evctores tambin se utilizara el smbolo de la flecha. Por ejemplo, A y B son matrices y x y b???  son vectores.

2 Operaciones elementales con matrices
2.1 Transpuesta de una matriz
Dada la matriz A se define la transpuesta de A y se denota por At=A' a la matriz cuyos elementos verifican que
atij=aji  ???i,j

En R esta operacin se realiza utilizando la funcin t().

Ejemplo

# Matriz B
B <- matrix(c(1,0,0,-1,0,1,0,0,1,0), ncol=2, byrow=TRUE) # se rellena por filas
B
##      [,1] [,2]
## [1,]    1    0
## [2,]    0   -1
## [3,]    0    1
## [4,]    0    0
## [5,]    1    0
# transpuesta de B
t(B)
##      [,1] [,2] [,3] [,4] [,5]
## [1,]    1    0    0    0    1
## [2,]    0   -1    1    0    0
2.2 Matriz conjugada
Dada la matriz A se define la matriz conjugada de A como aquella matriz A que es el resultado de la sustitucin de los elementos de la matriz A por sus conjugados. Es decir, la parte imaginaria de los elementos de la matriz cambia su signo.

Ejemplo

A <- matrix(c(2+1i, 4-1i, 1+0i, 3+0i, 5+0i, 3-1i, -1+4i, -2-2i, 1+3i), ncol=3)
A
##      [,1] [,2]  [,3]
## [1,] 2+1i 3+0i -1+4i
## [2,] 4-1i 5+0i -2-2i
## [3,] 1+0i 3-1i  1+3i
Conj(A)
##      [,1] [,2]  [,3]
## [1,] 2-1i 3+0i -1-4i
## [2,] 4+1i 5+0i -2+2i
## [3,] 1+0i 3+1i  1-3i
2.3 Suma de matrices
Dadas dos matrices A y B de igual dimensin se define la suma de matrices A+B=C como,
cij=aij+bij,  ???i,j

En R esta operacin se realiza utilizando la funcin suma '+'

Ejemplo

A <- matrix(1:20, nrow=5)
B <- matrix(21:40, nrow=5)
A 
##      [,1] [,2] [,3] [,4]
## [1,]    1    6   11   16
## [2,]    2    7   12   17
## [3,]    3    8   13   18
## [4,]    4    9   14   19
## [5,]    5   10   15   20
B
##      [,1] [,2] [,3] [,4]
## [1,]   21   26   31   36
## [2,]   22   27   32   37
## [3,]   23   28   33   38
## [4,]   24   29   34   39
## [5,]   25   30   35   40
A+B
##      [,1] [,2] [,3] [,4]
## [1,]   22   32   42   52
## [2,]   24   34   44   54
## [3,]   26   36   46   56
## [4,]   28   38   48   58
## [5,]   30   40   50   60
2.4 Producto de un escalar por una matriz
El producto de ?????R y A???Mnp es una matriz B tal que B=?????A=A?????
bij=?????aij

En R esta operacin se realiza utilizando la funcin producto '*' que multiplica el escalar por cada uno de los elemntos de la matriz.

Ejemplo

A <- matrix(1:20, nrow=5)
lambda <- 10
lambda*A
##      [,1] [,2] [,3] [,4]
## [1,]   10   60  110  160
## [2,]   20   70  120  170
## [3,]   30   80  130  180
## [4,]   40   90  140  190
## [5,]   50  100  150  200
A*lambda
##      [,1] [,2] [,3] [,4]
## [1,]   10   60  110  160
## [2,]   20   70  120  170
## [3,]   30   80  130  180
## [4,]   40   90  140  190
## [5,]   50  100  150  200
2.5 Producto matricial de dos matrices
El producto matricial de las matrices A y B, tales que A???Mnp y B???Mpm, es una matriz C=A???B tal que C???Mnm
cij=???r=1pair???brj

En R esta operacin se realiza utilizando la funcin producto '%*%'.

Ejemplo

# Matriz A
A <- matrix(c(1,0,0,0,3,0,2,0,1,0,1,0,-1,0,1), ncol=5)    # se rellena por columnas
A
##      [,1] [,2] [,3] [,4] [,5]
## [1,]    1    0    2    0   -1
## [2,]    0    3    0    1    0
## [3,]    0    0    1    0    1
# Matriz B
B <- matrix(c(1,0,0,-1,0,1,0,0,1,0), ncol=2, byrow=TRUE) # se rellena por filas
B
##      [,1] [,2]
## [1,]    1    0
## [2,]    0   -1
## [3,]    0    1
## [4,]    0    0
## [5,]    1    0
#Matric C = A%*%B
C <- A%*%B
C
##      [,1] [,2]
## [1,]    0    2
## [2,]    0   -3
## [3,]    1    1
2.6 Producto elemento a elemento de dos matrices
Dadas dos matrices A y B de igual dimensin se define el producto elemento a elemento de dos matrices AB=C como,
cij=aij???bij,  ???i,j

En R esta operacin se realiza utilizando la funcin producto '*'

Ejemplo

A <- matrix(1:20, nrow=5)
B <- matrix(21:40, nrow=5)
A 
##      [,1] [,2] [,3] [,4]
## [1,]    1    6   11   16
## [2,]    2    7   12   17
## [3,]    3    8   13   18
## [4,]    4    9   14   19
## [5,]    5   10   15   20
B
##      [,1] [,2] [,3] [,4]
## [1,]   21   26   31   36
## [2,]   22   27   32   37
## [3,]   23   28   33   38
## [4,]   24   29   34   39
## [5,]   25   30   35   40
A*B
##      [,1] [,2] [,3] [,4]
## [1,]   21  156  341  576
## [2,]   44  189  384  629
## [3,]   69  224  429  684
## [4,]   96  261  476  741
## [5,]  125  300  525  800
2.7 Producto cruzado de dos matrices
En el analisis multivariante es comn calcular AtA y AAt. Aunque se puede realiuzar este producto utilizando las operaciones de matrices definitas sobre las matrices, R dispone de dos funciones que facilitan el clculo.

crossprod(A) = t(A) %*% A
tcrossprod(A) = A %*% t(A)
En general es ms eficiente al calculo del producto cruzado de dos matrices por medio de las funciones crossprod()y tcrossprod().

Ejemplo

# Matriz A
A <- matrix(c(1,0,0,0,3,0,2,0,1,0,1,0,-1,0,1), ncol=5)    # se rellena por columnas
A
##      [,1] [,2] [,3] [,4] [,5]
## [1,]    1    0    2    0   -1
## [2,]    0    3    0    1    0
## [3,]    0    0    1    0    1
# Producto cruzado
crossprod(A)
##      [,1] [,2] [,3] [,4] [,5]
## [1,]    1    0    2    0   -1
## [2,]    0    9    0    3    0
## [3,]    2    0    5    0   -1
## [4,]    0    3    0    1    0
## [5,]   -1    0   -1    0    2
crossprod(A) == t(A) %*% A
##      [,1] [,2] [,3] [,4] [,5]
## [1,] TRUE TRUE TRUE TRUE TRUE
## [2,] TRUE TRUE TRUE TRUE TRUE
## [3,] TRUE TRUE TRUE TRUE TRUE
## [4,] TRUE TRUE TRUE TRUE TRUE
## [5,] TRUE TRUE TRUE TRUE TRUE
2.8 Determinante de una matriz
El determinante de una matriz M cuadrada de orden n es una funcin que le asigna a la matriz M, un nico nmero real llamado el determinante de la matriz y se representa por det(M) o por |M|.

En R la funcin det() calcula el determinante de las matrices cuadradas.

3 Tipos de matrices
3.1 Matrices cuadradas
Se dice que una matriz A es cuadrada si tiene el mismo nmero de filas que de columnas.

Ejemplo

# Matriz cuadrada
cuadrada <- matrix(1:16, ncol=4)
cuadrada
##      [,1] [,2] [,3] [,4]
## [1,]    1    5    9   13
## [2,]    2    6   10   14
## [3,]    3    7   11   15
## [4,]    4    8   12   16
3.2 Matrices rectangulares
Se dice que una matriz A???Mnp es rectangular si no es cuadrada. es decir si tiene el distinto nmero de filas que de columnas (n???p).

Una matriz rectagular es vertical o alta si el nmero de filas es mayor que el nmero de columnas

Ejemplo

# Matriz alta
alta <- matrix(1:16, ncol=2)
alta
##      [,1] [,2]
## [1,]    1    9
## [2,]    2   10
## [3,]    3   11
## [4,]    4   12
## [5,]    5   13
## [6,]    6   14
## [7,]    7   15
## [8,]    8   16
Una matriz rectagular es horizontal o ancha si el nmero de filas es menor que el nmero de columnas

Ejemplo

# Matriz alta
ancha <- matrix(1:16, ncol=8)
ancha
##      [,1] [,2] [,3] [,4] [,5] [,6] [,7] [,8]
## [1,]    1    3    5    7    9   11   13   15
## [2,]    2    4    6    8   10   12   14   16
3.3 Matriz simtrica
Una matriz M es simtrica cuando es una matriz cuadrada, y es igual a su traspuesta (mij=mji  ???i,j).
M=Mt

Ejemplo

# Matriz M
M <- matrix(c(1,2,3,2,4,1,3,1,4), nrow=3, byrow=TRUE)
# Matriz trasnpuesta de M
t(M)
##      [,1] [,2] [,3]
## [1,]    1    2    3
## [2,]    2    4    1
## [3,]    3    1    4
# Comprobar la simetra elemnto a elemento
M == t(M)
##      [,1] [,2] [,3]
## [1,] TRUE TRUE TRUE
## [2,] TRUE TRUE TRUE
## [3,] TRUE TRUE TRUE
# Comprobar la simetra de forma global
identical(M,t(M))
## [1] TRUE
3.4 Matriz diagonal
Una matriz M es diagonal cuando es una matriz cuadrada y todos sus elemtos son nulos salvo los de la diagonal principal.
mij=0  ???i???j

Se verifica que toda matriz diagonal es simtrica.

En R la funcin diag() permite trabajar con matrices diagonales.

1 La funcin diag() permite crear matrices diagonales.

# Crear una matriz diagonal
diagonal <- diag(c(1,2,3,4))
diagonal
##      [,1] [,2] [,3] [,4]
## [1,]    1    0    0    0
## [2,]    0    2    0    0
## [3,]    0    0    3    0
## [4,]    0    0    0    4
2 La funcin diag() permite extraer la diagonal de una matriz cuadrada.

# Extraer la diagonal principal
# Matriz cuadrada
cuadrada <- matrix(1:9, nrow=3, ncol=3)
cuadrada
##      [,1] [,2] [,3]
## [1,]    1    4    7
## [2,]    2    5    8
## [3,]    3    6    9
# La diagonal es
diag(cuadrada)
## [1] 1 5 9
3.5 Matriz identidad
Una matriz I es una matriz identidad si es una matriz diagonal con todos los elementos de la diagonal igual a 1.

En R la funcin diag() permite crear matrices identidad.

# Matriz identidad de orden 4
identidad <- diag(1, nrow=4, ncol=4)   # Recycling
identidad
##      [,1] [,2] [,3] [,4]
## [1,]    1    0    0    0
## [2,]    0    1    0    0
## [3,]    0    0    1    0
## [4,]    0    0    0    1
3.6 Matriz J
Una matriz M es una matriz J si todos sus elementos son igual a 1.

# Matriz J de 4x3
J <- matrix(1,nrow=4,ncol=3)
J
##      [,1] [,2] [,3]
## [1,]    1    1    1
## [2,]    1    1    1
## [3,]    1    1    1
## [4,]    1    1    1
3.7 Matriz nula
Una matriz M es una matriz nula si todos sus elementos son igual a 0.

# Matriz nula de 4x3
nula <- matrix(0,nrow=4,ncol=3)
nula
##      [,1] [,2] [,3]
## [1,]    0    0    0
## [2,]    0    0    0
## [3,]    0    0    0
## [4,]    0    0    0
3.8 Matriz idempotente
Una matriz M es una matriz idempotente si es cuadrada y verifica que M???M=M2=M

Ejemplo

# La siguiente matriz M es idempotente
B <- matrix(c(2,-1,1,-3,4,-3,-5,5,-4), nrow=3)
# Comprobacin elemento a elemento
B%*%B == B
##      [,1] [,2] [,3]
## [1,] TRUE TRUE TRUE
## [2,] TRUE TRUE TRUE
## [3,] TRUE TRUE TRUE
# Comprobacin global
identical(B%*%B,B)
## [1] TRUE
3.9 Matriz nilpotente
Una matriz M es una matriz nilpotente si es cuadrada y existe k???Z+ tal que Mk=0

Ejemplo Comprueba que la siguiente matriz M es nilpotente de orden 4.
M=???????????????1000210042108421???????????????.

M <- matrix(c(0,-2,-4,-8,0,0,-2,-4,0,0,0,-2,0,0,0,0), ncol=4, byrow=TRUE)
M
##      [,1] [,2] [,3] [,4]
## [1,]    0   -2   -4   -8
## [2,]    0    0   -2   -4
## [3,]    0    0    0   -2
## [4,]    0    0    0    0
M%*%M
##      [,1] [,2] [,3] [,4]
## [1,]    0    0    4   16
## [2,]    0    0    0    4
## [3,]    0    0    0    0
## [4,]    0    0    0    0
M%*%M%*%M
##      [,1] [,2] [,3] [,4]
## [1,]    0    0    0   -8
## [2,]    0    0    0    0
## [3,]    0    0    0    0
## [4,]    0    0    0    0
M%*%M%*%M%*%M
##      [,1] [,2] [,3] [,4]
## [1,]    0    0    0    0
## [2,]    0    0    0    0
## [3,]    0    0    0    0
## [4,]    0    0    0    0
3.10 Matriz ortogonal
Una matriz U???Mnk es ortogonal si el producto de la matriz por su traspuesta es igual a la matriz identidad de Mnn.
U???Ut=I

Ejemplo Comprueba si la siguiente matriz M es ortogonal.
M=?????????1000010???10?????????.

M <- matrix(c(1,0,0,0,0,1,0,-1,0), ncol=3)
M%*%t(M)
##      [,1] [,2] [,3]
## [1,]    1    0    0
## [2,]    0    1    0
## [3,]    0    0    1
3.11 Matriz triangular superior
Una matriz M es una matriz si mij=0,  ???i>j

# Matriz triangular superior
triangular.superior <- matrix(c(1,0,0,2,4,0,3,5,6), nrow=3)
triangular.superior
##      [,1] [,2] [,3]
## [1,]    1    2    3
## [2,]    0    4    5
## [3,]    0    0    6
3.12 Matriz triangular inferior
Una matriz M es una matriz si mij=0,  ???i<j

# Matriz triangular inferior
triangular.inferior <- matrix(c(1,0,0,2,4,0,3,5,6), nrow=3)
triangular.inferior
##      [,1] [,2] [,3]
## [1,]    1    2    3
## [2,]    0    4    5
## [3,]    0    0    6
En R se disponen de las funciones lower.tri() y upper.tri() para extraer sub-matrices triangulares.

3.12.1 Funcin lower.tri()
Dada una matriz cuadrada, M, la funcin lower.tri() permite extraer la sub-matriz triangular superior asociada.

# Matriz cuadrada
M <- matrix(1:9, 3, 3)
M
##      [,1] [,2] [,3]
## [1,]    1    4    7
## [2,]    2    5    8
## [3,]    3    6    9
#lower.tri()
lower.tri(M)
##       [,1]  [,2]  [,3]
## [1,] FALSE FALSE FALSE
## [2,]  TRUE FALSE FALSE
## [3,]  TRUE  TRUE FALSE
#Extraer la sub-matriz superior
M[lower.tri(M)] <- 0
M
##      [,1] [,2] [,3]
## [1,]    1    4    7
## [2,]    0    5    8
## [3,]    0    0    9
3.12.2 Funcin upper.tri()
Dada una matriz cuadrada, M, la funcin upper.tri() permite extraer la sub-matriz triangular inferior asociada.

# Matriz cuadrada
M <- matrix(1:9, 3, 3)
M
##      [,1] [,2] [,3]
## [1,]    1    4    7
## [2,]    2    5    8
## [3,]    3    6    9
#upper.tri()
upper.tri(M)
##       [,1]  [,2]  [,3]
## [1,] FALSE  TRUE  TRUE
## [2,] FALSE FALSE  TRUE
## [3,] FALSE FALSE FALSE
#Extraer la sub-matriz inferior
M[upper.tri(M)] <- 0
M
##      [,1] [,2] [,3]
## [1,]    1    0    0
## [2,]    2    5    0
## [3,]    3    6    9
3.13 Traza de una matriz
La traza de una matriz cuadrada es la suma de los elementos de su diagonal principal. Dada la matriz,

A=???????????????15913261014371115481216???????????????

su traza es,
tr(A)=1+6+11+16=34

Para calcular la traza en R,

Se extrae los elementos de la diagonal principal con la funcin diag().
Se suman estos elementos con la funcin sum().
# Matriz A
(A <- matrix(1:16,4))
##      [,1] [,2] [,3] [,4]
## [1,]    1    5    9   13
## [2,]    2    6   10   14
## [3,]    3    7   11   15
## [4,]    4    8   12   16
# Traza de A
sum(diag(A))
## [1] 34
Traza del producto de matrices

La traza del producto de matrices multiplicables verifica que,

tr(ABC)=tr(BCA)=tr(CAB)

Norma eucldea de Frobenius La norma eucldea es una operacin matricial que se utiliza para determinar las posibles diferencias entre dos matrices del mismo orden. Se define como,

||A||=[tr(AA')]12=[???i=1n???j=1na2ij]12

En nuestro ejemplo,

||A||=(12+22+???+152+162)=1496